=== debian/changelog ===
reposurgeon (3.29-1) unstable; urgency=medium

  * Initial release (Closes: #702485)

 -- Anthony Fok <foka@debian.org>  Fri, 25 Sep 2015 12:07:58 -0600

reposurgeon (3.18-1) UNRELEASED; urgency=low

  * First attempt at Initial release, rejected due to inconsistent
    license in revdir.c (GPL-2) vs the rest (GPL-2+) of the
    cvs-fast-export package, which reposurgeon recommends.
    (would have closed #702485)
  * Cherry-pick minor post-3.18 fixes from upstream.

 -- Anthony Fok <foka@debian.org>  Sat, 20 Dec 2014 13:21:08 -0700
