=== debian/control ===
Source: reposurgeon
Section: vcs
Priority: optional
Maintainer: Anthony Fok <foka@debian.org>
Build-Depends: debhelper (>= 9), dh-python, python (>= 2.7.2-7), xmlto, asciidoc
X-Python-Version: >= 2.7.2
Standards-Version: 3.9.6
Homepage: http://www.catb.org/esr/reposurgeon/
Vcs-Git: git://anonscm.debian.org/collab-maint/reposurgeon.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/reposurgeon.git

Package: reposurgeon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
Recommends: git, cvs-fast-export
Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
Description: Tool for editing version-control repository history
 reposurgeon enables risky operations that version-control systems don't want 
 to let you do, such as editing past comments and metadata and removing
 commits.  It works with any version control system that can export and 
 import git fast-import streams, including git, hg, fossil, bzr, CVS, and RCS. 
 It can also read Subversion dump files directly and can thus be used to script
 production of very high-quality conversions from Subversion to any 
 supported DVCS.
 .
 repodiffer is a program that reports differences between repository 
 histories. It uses a diff(1)-like algorithm to identify spans of
 identical revisions, and to pick out revisions that have been 
 changed or deleted or inserted. It may be useful for comparing the
 output of different repository-conversion tools in detail.
 .
 Another auxiliary program, repopuller, assists in mirroring Subversion
 repositories.
