=== debian/watch ===
version=3
http://www.catb.org/~esr/reposurgeon/reposurgeon-(\d[\d.]*)\.tar\.(?:gz|bz2|xz)
