=== debian/changelog ===
reposurgeon (3.37-1) unstable; urgency=medium

  * New upstream version
  * Change license from BSD-3-Clause to BSD-2-Clause as upstream has done
  * Bump Standards-Version to 3.9.8 (no change)
  * Use secure https URLs for Vcs-* fields
  * Update dependency on Python 2 to Python 3
  * Update package description listing renamed executables correctly.
    Thanks to Alberto Luaces for the heads up. (Closes: #822979)

 -- Anthony Fok <foka@debian.org>  Sun, 01 May 2016 02:21:32 +0800
