=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 %:
-	dh $@ --with python2
+	dh $@ --with python3
 
 override_dh_auto_install:
 	dh_auto_install -- prefix=/usr
