## reposurgeon 3.42

=== ci/requirements.txt ===
mercurial
pylint>=1.2,<1.5
astroid>=1.3.3,<1.4
