=== debian/changelog ===
reposurgeon (3.42-2ubuntu1) artful; urgency=medium

  * Non-maintainer upload.
  * debian/patches/pylint-fixes.patch: fixes for new python linting
    warnings.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 27 Aug 2017 07:41:13 +0000

reposurgeon (3.42-2) unstable; urgency=medium

  * Skip building cyreposurgeon on mips, mipsel and sh4.
    This is to prevent build machines for these architectures
    from running out of memory during the cython/cc1 run.
  * Skip building cyreposurgeon on hurd-i386 too
    to see if it fixes the failed test later on.
  * Ignore git build-dependency on alpha/ppc64/sparc64/x32 temporarily.
    For some reasons, git (1:2.13.3-1) from July 2017 fails to build
    on these architectures, causing BD-Uninstallable for reposurgeon.
    Fortunately, reposurgeon skips git-related tests gracefully
    when git is not installed.

 -- Anthony Fok <foka@debian.org>  Fri, 04 Aug 2017 20:49:28 -0600

reposurgeon (3.42-1) unstable; urgency=medium

  * New upstream release
  * Use debhelper (>= 10)
  * Bump Standards-Version to 4.0.0:
    Use https form of the copyright-format URL in debian/copyright
  * Revert from Python 3 to Python 2 to pass all tests
  * Build cyreposurgeon too with cython
  * Add "Build-Depends: cvs, git, mercurial, subversion" for tests

 -- Anthony Fok <foka@debian.org>  Fri, 04 Aug 2017 12:08:16 -0600
