=== debian/control ===
--- 
+++ 
@@ -1,16 +1,20 @@
 Source: reposurgeon
 Section: vcs
 Priority: optional
-Maintainer: Anthony Fok <foka@debian.org>
-Build-Depends: debhelper (>= 9), dh-python, python3, xmlto, asciidoc
-Standards-Version: 3.9.8
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
+Build-Depends: debhelper (>= 10), dh-python,
+               python, cython, libpython-dev, pkg-config, pylint,
+               xmlto, asciidoc-base,
+               cvs, git [!alpha !ppc64 !sparc64 !x32], mercurial, subversion
+Standards-Version: 4.0.0
 Homepage: http://www.catb.org/esr/reposurgeon/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/reposurgeon.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/reposurgeon.git
 
 Package: reposurgeon
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 Recommends: git, cvs-fast-export
 Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
 Description: Tool for editing version-control repository history
