=== debian/rules ===
--- 
+++ 
@@ -14,8 +14,22 @@
 # package maintainers to append LDFLAGS
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+
 %:
-	dh $@ --with python3
+	dh $@ --with python2
+
+ifeq ($(filter mips mipsel hurd-i386 sh4,$(DEB_BUILD_ARCH)),)
+override_dh_auto_build:
+	dh_auto_build -- all cyreposurgeon
 
 override_dh_auto_install:
+	dh_auto_install -- prefix=/usr install-cyreposurgeon
+else
+override_dh_auto_install:
 	dh_auto_install -- prefix=/usr
+endif
+
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f test/python
