## reposurgeon 3.44

=== Makefile ===
--- 
+++ 
@@ -4,6 +4,7 @@
 
 INSTALL=install
 XMLTO=xmlto
+XMLTOOPTS=-m docbook-extra.xml
 ASCIIDOC=asciidoc
 PYLINT=pylint
 prefix?=/usr/local
@@ -15,9 +16,8 @@
 pyinclude?=$(shell pkg-config --cflags python-$(PYVERSION) || echo "-I/usr/include/python$(PYVERSION)")
 pylib?=$(shell pkg-config --libs python-$(PYVERSION) || echo "-lpython$(PYVERSION)")
 
-VERS=$(shell sed <reposurgeon -n -e '/version=\(.*\)/s//\1/p')
-
-SOURCES = README.md NEWS AUTHORS COPYING TODO
+VERS=$(shell sed <reposurgeon -n -e '/version=\"\(.*\)\"/s//\1/p')
+SOURCES += docbook-extra.xml nofooter.conf
 SOURCES += \
 	reposurgeon reposurgeon.xml \
 	repotool repotool.xml \
@@ -29,22 +29,24 @@
 SOURCES += Makefile control reposturgeon.png reposurgeon-git-aliases
 SOURCES += Dockerfile ci/prepare.sh ci/Makefile ci/requirements.txt
 
-.PHONY: all install install-cyreposurgeon clean version pylint check zip release refresh \
+.PHONY: all install clean uninstall version pylint check zip release refresh \
     docker-build docker-check docker-check-noscm
-.INTERMEDIATE: cyreposurgeon.c cyrepodiffer.c
-.PRECIOUS: cyreposurgeon.o cyrepodiffer.o
 
+BINARIES = reposurgeon repotool repodiffer repomapper repocutter
 MANPAGES = reposurgeon.1 repotool.1 repodiffer.1 repomapper.1 repocutter.1
-all:  $(MANPAGES) $(MANPAGES:.1=.html) \
-     dvcs-migration-guide.html features.html reporting-bugs.html
+HTMLFILES = $(MANPAGES:.1=.html) \
+            dvcs-migration-guide.html features.html reporting-bugs.html
+SHARED    = README.md NEWS TODO reposurgeon-git-aliases $(HTMLFILES)
+
+all:  $(MANPAGES) $(HTMLFILES)
 
 %.1: %.xml
-	$(XMLTO) man $<
+	$(XMLTO) $(XMLTOOPTS) man $<
 
 %.html: %.xml
-	$(XMLTO) html-nochunks $<
+	$(XMLTO) $(XMLTOOPTS) html-nochunks $<
 
-dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc
+dvcs-migration-guide.html: ASCIIDOC_ARGS=-a toc -f nofooter.conf
 %.html: %.asc
 	$(ASCIIDOC) $(ASCIIDOC_ARGS) $<
 
@@ -65,20 +67,25 @@
 	$(INSTALL) -d "$(target)/bin"
 	$(INSTALL) -d "$(target)/share/doc/reposurgeon"
 	$(INSTALL) -d "$(target)/$(mandir)/man1"
-	$(INSTALL) -m 755 reposurgeon repomapper repotool repodiffer repocutter "$(target)/bin"
-	$(INSTALL) -m 644 README.md NEWS TODO reposurgeon-git-aliases *.html \
-		"$(target)/share/doc/reposurgeon"
-	$(INSTALL) -m 644 *.1 "$(target)/$(mandir)/man1"
-
-install-cyreposurgeon: cyreposurgeon
-	$(INSTALL) -d "$(target)/bin"
-	$(INSTALL) -m 755 cyreposurgeon "$(target)/bin"
+	$(INSTALL) -m 755 $(BINARIES) "$(target)/bin"
+	$(INSTALL) -m 644 $(SHARED) "$(target)/share/doc/reposurgeon"
+	$(INSTALL) -m 644 $(MANPAGES) "$(target)/$(mandir)/man1"
 
 clean:
 	rm -fr  *~ *.1 *.html *.tar.xz MANIFEST *.md5
 	rm -fr .rs .rs* test/.rs test/.rs*
 	rm -f typescript test/typescript *.pyc
-	rm -f cyreposurgeon.c cyreposurgeon.o cyreposurgeon
+
+# Uninstallation
+INSTALLED_BINARIES := $(BINARIES:%="$(target)/bin/%")
+INSTALLED_SHARED   := $(SHARED:%="$(target)/share/doc/reposurgeon/%")
+INSTALLED_MANPAGES := $(MANPAGES:%="$(target)/$(mandir)/man1/%")
+
+uninstall:
+	rm -f $(INSTALLED_BINARIES)
+	rm -f $(INSTALLED_MANPAGES)
+	rm -f $(INSTALLED_SHARED)
+	rmdir "$(target)/share/doc/reposurgeon"
 
 version:
 	@echo $(VERS)
@@ -90,10 +97,10 @@
 COMMON_PYLINT = --rcfile=/dev/null --reports=n \
 	--msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
 	--dummy-variables-rgx='^_'
-PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C1001,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0640,W0511,W0611,E0611,E1101,E1103,E1124,I0011,F0401"
-PYLINTOPTS2 = "C0103,C0111,C0325,C0301,C0326,C0330,C0410,C1001,W0603,W0621,E1101,E1103,R0401,R0902,R0903,R0912,R0914,R0915"
+PYLINTOPTS1 = "C0103,C0111,C0301,C0302,C0322,C0324,C0325,C0321,C0323,C0330,C0410,C0411,C0412,C0413,C1001,C1801,R0201,R0101,R0204,R0902,R0903,R0904,R0911,R0912,R0913,R0914,R0915,R1705,W0108,W0110,W0123,W0122,W0141,W0142,W0212,W0221,W0232,W0233,W0603,W0632,W0633,W0640,W0511,W0611,E0611,E1101,E1103,E1124,E1133,I0011,F0401"
+PYLINTOPTS2 = "C0103,C0111,C0325,C0301,C0326,C0330,C0410,C1001,W0603,W0621,E1101,E1103,R0401,R0902,R0903,R0912,R0914,R0915,R1705"
 PYLINTOPTS3 = "C0103,C0301,C0410,C1001,R0401,R0903,W0621"
-PYLINTOPTS4 = "C0103,C0301,C0325,C0111,C0410,C0413,C1001,R0101,R0903,R0401,R0912,R0913,R0914,R0915,W0110,W0141,W0621,W1504"
+PYLINTOPTS4 = "C0103,C0301,C0302,C0325,C0111,C0410,C0413,C1001,C1801,R0101,R0903,R0401,R0912,R0913,R0914,R0915,R1705,W0110,W0141,W0603,W0621,W1504"
 pylint:
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS1) reposurgeon
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS2) repodiffer
@@ -101,7 +108,10 @@
 	@$(PYLINT) $(COMMON_PYLINT) --disable=$(PYLINTOPTS4) repocutter
 
 check:
-	cd test; $(MAKE) --quiet
+	cd test; $(MAKE) --quiet check
+
+portcheck:
+	cd test; $(MAKE) --quiet portcheck
 
 #
 # Continuous integration.  More specifics are in the ci/ directory
@@ -132,10 +142,7 @@
 #
 
 reposurgeon-$(VERS).tar.xz: $(SOURCES)
-	@ls $(SOURCES) | sed s:^:reposurgeon-$(VERS)/: >MANIFEST
-	@(cd ..; ln -s reposurgeon reposurgeon-$(VERS))
-	(cd ..; tar -cJf reposurgeon/reposurgeon-$(VERS).tar.xz `cat reposurgeon/MANIFEST`)
-	@(cd ..; rm reposurgeon-$(VERS))
+	tar --transform='s:^:reposurgeon-$(VERS)/:' --show-transformed-names -cJf reposurgeon-$(VERS).tar.xz $(SOURCES) test
 
 dist: reposurgeon-$(VERS).tar.xz reposurgeon.1 repotool.1 repodiffer.1
