=== test/Makefile ===
--- 
+++ 
@@ -16,22 +16,30 @@
 # that confuse diff
 TERM := dumb
 
-default:
-	@(cd ..; make -e --quiet pylint)
+default: check
+
+# Speed check - test under the default in the hashbang line
+check:
+	@if command -v pylint >/dev/null 2>&1; then echo "=== Running pylint" && (cd ..; make -e --quiet pylint); else echo "pylint missing; skipping tests"; fi
+	@echo "=== Running built-in tests"
 	@$(REPOSURGEON) "runtests"
-	@setpython python2
-	@make -e --quiet all
-	@setpython python3
-	@make -e --quiet all
-	@setpython python
+	@if ./setpypy pypy; then time make -e --quiet all; else echo "pypy missing; skipping tests"; fi
+
+# Portability check - tests all dialects
+portcheck: check
+	@if ./setpypy python2; then time make -e --quiet all; else echo "python2 missing; skipping tests"; fi
+	@if ./setpypy python3; then time make -e --quiet all; else echo "python3 missing; skipping tests"; fi
+	@./setpypy pypy
 
 all: listcheck roundtrip roundtrip-compress mailboxing fi-regress coalesce \
 		git-regress git-regress-branches git-regress-merges git-regress-tags \
-		hg-regress hg-regress-branches hg-regress-merges hg-regress-tags hg-regress-patho \
-		svnload-regress legacy-regress svndump-regress \
+		hg-extractor svnload-regress liftcheck-regress legacy-regress svndump-regress \
 		repodiffer-regress repomapper-regress \
-		repotool-regress repocutter-regress
+		repotool-regress repocutter-regress svncheck-regress
 	@echo "=== No diff output is good news."
+
+hg-extractor: hg-regress hg-regress-branches hg-regress-merges \
+		hg-regress-tags hg-regress-patho
 
 .SUFFIXES: .svn .chk .fi .map
 
@@ -44,7 +52,8 @@
 
 buildregress: fi-buildregress svnload-buildregress legacy-buildregress \
 	svndump-buildregress repodiffer-buildregress repomapper-buildregress \
-	repocutter-buildregress hg-buildregress-branches hg-buildregress-patho
+	repotool-buildregress repocutter-buildregress hg-buildregress-branches \
+	hg-buildregress-patho svncheck-buildregress
 
 clean:
 	rm -fr .rs* test-repo test-checkout git-repo left-repo right-repo *~
@@ -285,7 +294,7 @@
 hg-buildregress-patho:
 	@for file in $(HGPATHO); do \
 	    echo "Remaking $${file}.fi"; \
-	    ./hg-$${file}-test | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
+	    ./hg-$${file}-test 2>/dev/null | sed -e 1d -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >$${file}.fi \
 		2>&1 || exit 1; \
 	done
 hg-regress-patho:
@@ -294,7 +303,7 @@
 	then \
 	    for test in $(HGPATHO); do \
 		if (echo "  $${test}" >&2; \
-		./hg-$${test}-test) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
+		./hg-$${test}-test 2>/dev/null) | sed -e '/^#legacy-id/d' | sed -e '/^#reposurgeon sourcetype/d' >/tmp/regress$$$$; \
 		then diff --text -u $${test}.fi /tmp/regress$$$$ || exit 1; \
 		else echo "*** Nonzero return status on $${test}!"; exit 1; fi \
 	    done; \
@@ -321,25 +330,3 @@
 	    then \
 		(if { $(ECHO) -n "  $${test}.svn"; grep --text '^ ##' $${test}.svn || echo ' ## (no description)'; } >&2; \
 		$(REPOSURGEON) "read <$${test}.svn" "prefer git" "write -" >/tmp/regress$$$$ 2>&1; \
-		then diff --text -u $${test}.chk /tmp/regress$$$$ || exit 1; \
-		else echo "*** Nonzero return status on $${test}!"; exit 1; fi; \
-		if command -v git >/dev/null 2>&1 ; \
-		then \
-		    mkdir /tmp/reposurgeon$$$$ || exit 1; \
-		    (cd /tmp/reposurgeon$$$$ || exit 1; \
-			git init --quiet || exit 1; \
-			grep --text -v 'reposurgeon:' /tmp/regress$$$$ | git fast-import --quiet) \
-			    || exit 1; \
-		    rm -fr /tmp/reposurgeon$$$$\
-		else echo "    Skipped, git missing."; \
-		fi \
-		) || exit 1; \
-	    fi \
-	done
-	@rm -f /tmp/regress$$$$
-
-REFLOADS=references mergeinfo-with-split
-legacy-buildregress:
-	@for test in $(REFLOADS); \
-	do \
-	    echo "Remaking $${test}.map"; \
