=== debian/changelog ===
reposurgeon (3.44-3) unstable; urgency=medium

  * Add build and runtime dependency on tzdata, which is no longer
    build-essential, and build chroots are not required to have it
    pre-installed, leading to FTBFS during a reposurgeon date test
    checking whether EST equals to -0500.  Thanks to Lucas Nussbaum
    for the report!  (Closes: #871163)
  * Fall back to /usr/bin/editor when $EDITOR is not set.
    This is to comply with Debian Policy §11.4, see
    https://www.debian.org/doc/debian-policy/#editors-and-pagers
    Thanks to Jakub Wilk for the report!  (Closes: #877011)
  * Remove now unneeded build dependency on libpython-dev

 -- Anthony Fok <foka@debian.org>  Tue, 17 Jul 2018 01:42:21 -0600

reposurgeon (3.44-2) unstable; urgency=medium

  * Switch from dh_python2 to dh_pypy properly.
    This fixes uninstallable pypy:any dependency in reposurgeon (3.44-1).
  * Change Architecture from "any" to "all"
  * Change nonexistent "svn" to "subversion" in Suggests field
  * Remove unneeded DEB_BUILD_ARCH and override_dh_auto_clean

 -- Anthony Fok <foka@debian.org>  Fri, 13 Jul 2018 07:27:18 -0600

reposurgeon (3.44-1) unstable; urgency=medium

  * New upstream release 3.44:
     - New 'setperm' command for patching file path permissions.
     - Abandon cyreposurgeon in favor of PyPy, which gives a better speedup.
     - Max working-set size has been reduced, enabling handling of larger repos.
     - New 'gitify' command for massaging comments into git conventional form.
     - The tag command now allows deleting all tags matching a regexp.
     - Fix crash when chaining '|', '&', '?' selection operators.
  * Abandon cyreposurgeon in favor of PyPy as per upstream (Closes: #879504)
  * Remove dependency on cython, and dependency on pypy and time,
  * Restore git build-dependency on alpha/ppc64/sparc64/x32
  * Restore missing README.md and friends from 3.44 release tarball
  * Prevent pylint from writing to /nonexistent home directory
    by adding "export PYLINTHOME := $(CURDIR)/.pylint.d" to debian/rules
  * Point Vcs-* URLs to salsa.debian.org
  * Rename debian-branch to debian/sid
  * Apply "cme fix dpkg" fixes to debian/control,
    bumping Standards-Version to 4.1.5, etc.
  * Use debhelper (>= 11)
  * Add debian/clean

 -- Anthony Fok <foka@debian.org>  Fri, 13 Jul 2018 04:33:48 -0600
