=== debian/control ===
--- 
+++ 
@@ -1,22 +1,39 @@
 Source: reposurgeon
+Maintainer: Anthony Fok <foka@debian.org>
 Section: vcs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Anthony Fok <foka@debian.org>
-Build-Depends: debhelper (>= 10), dh-python,
-               python, cython, libpython-dev, pkg-config, pylint,
-               xmlto, asciidoc-base,
-               cvs, git [!alpha !ppc64 !sparc64 !x32], mercurial, subversion
-Standards-Version: 4.0.0
+Build-Depends: debhelper (>= 11),
+               dh-python,
+               pypy,
+               python,
+               pkg-config,
+               pylint,
+               time,
+               tzdata,
+               xmlto,
+               asciidoc-base,
+               cvs,
+               git,
+               mercurial,
+               subversion
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/debian/reposurgeon
+Vcs-Git: https://salsa.debian.org/debian/reposurgeon.git
 Homepage: http://www.catb.org/esr/reposurgeon/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/reposurgeon.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/reposurgeon.git
 
 Package: reposurgeon
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
-Recommends: git, cvs-fast-export
-Suggests: bzr-fastimport, hg-fast-export, svn, darcs, fossil
+Architecture: all
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+         ${pypy:Depends},
+         tzdata
+Recommends: git,
+            cvs-fast-export
+Suggests: bzr-fastimport,
+          hg-fast-export,
+          subversion,
+          darcs,
+          fossil
 Description: Tool for editing version-control repository history
  `reposurgeon` enables risky operations that version-control systems
  don't want to let you do, such as (a) editing past comments and metadata,
